<?php
/* Liest eine Template Datein ein: */
function gettemplate($template) {
  global $settings;		
   
  $out = implode("",file($settings['loc']."templates/".$template.".".$settings['endung']));		
	return str_replace("\"","\\\"",$out);
}



/* Ersetzt Platzhalter und gibt die Template Datei aus: */
function showtemplate($template) {
  global $settings;        

  $template = str_replace("{basicurl}", $settings['url'], $template);		  
  $template = str_replace("{title}", $settings['title'], $template);
  $template = str_replace("{headline}", $settings['headline'], $template);
  $template = str_replace("{bgcolor}", $settings['bgcolor'], $template);
  $template = str_replace("{bgcolor2}", $settings['bgcolor2'], $template);
  $template = str_replace("{menubgcolor}", $settings['menubgcolor'], $template);
  $template = str_replace("{version}", $settings['version'], $template);  
  $template = str_replace("{mainwidth}", $settings['mainwidth'], $template);
  
  echo $template;
}



/* Generiert ein Passwort */
function getRandPass($len){
  $pw = ''; 
  for($i=0; $i < $len; $i++){
    switch(rand(1,3)){
      case 1: $pw.=chr(rand(48,57));  break; //0-9
      case 2: $pw.=chr(rand(65,90));  break; //A-Z
      case 3: $pw.=chr(rand(97,122)); break; //a-z
    }
  }
  return $pw;
} 



/* Wandelt HTML in HRC Codes um: */
function  html2hrc($text) {	
  //Horizontale Linie:
  $text = str_replace("<hr>", "[hr]", $text);  
  //Textformatierungen:
	$text = preg_replace("/<b>(.*)<\/b>/iUms", "[b]\\1[/b]", $text);
	$text = preg_replace("/<i>(.*)<\/i>/iUms", "[i]\\1[/i]", $text);
	$text = preg_replace("/<u>(.*)<\/u>/iUms", "[u]\\1[/u]", $text);
	$text = preg_replace("/<strike>(.*)<\/strike>/iUms", "[s]\\1[/s]", $text);
  //E-Mail Adressen:
	$text = preg_replace("/<a href=\"mailto:(.*)\">(.*)<\/a>/msiU", "[email]\\1[/email]", $text);
  //Links:
	$text = preg_replace("/<a href=\"(.*)\" target=\"_blank\">(.*)<\/a>/iUms", "[url=\\1]\\2[/url]", $text);		
  //Bilder:
	$text = preg_replace("/<center><img src=\"(.*)\" alt=\"bild\"><\/center>/iUms","[img]\\1[/img]",$text); //old Tag
  $text = preg_replace("/<div align=\"center\"><img src=\"(.*)\" border=\"0\" alt=\"bild\"><\/div>/iUms", "[img]\\1[/img]", $text); //new Tag
  //Farbiger Text:
	$text = preg_replace("/<span style=\"color:green\">(.*)<\/span>/iUms", "[green]\\1[/green]", $text);
	$text = preg_replace("/<span style=\"color:red\">(.*)<\/span>/iUms", "[red]\\1[/red]", $text);
	$text = preg_replace("/<span style=\"color:blue\">(.*)<\/span>/iUms", "[blue]\\1[/blue]", $text);
	$text = preg_replace("/<span style=\"color:white\">(.*)<\/span>/iUms", "[white]\\1[/white]", $text);	
  
	return $text;	
} 



/* Wandelt HRC in HTML Codes um: */
function hrc2html($text){
  //URLs in HRC umwandeln:
	$text = eregi_replace("([ \r\n])http://([^ ,\r\n]*)", "\\1[url]http://\\2[/url]", $text);
  $text = eregi_replace("([ \r\n])https://([^ ,\r\n]*)", "\\1[url]https://\\2[/url]", $text);
  $text = eregi_replace("([ \r\n])ftp://([^ ,\r\n]*)", "\\1[url]ftp://\\2[/url]", $text);
  $text = eregi_replace("([ \r\n])www\\.([^ ,\r\n]*)", "\\1[url]http://www.\\2[/url]", $text);
  $text = eregi_replace("^http://([^ ,\r\n]*)", "[url]http://\\1[/url]", $text);
  $text = eregi_replace("^https://([^ ,\r\n]*)", "[url]https://\\1[/url]", $text);
  $text = eregi_replace("^ftp://([^ ,\r\n]*)", "[url]ftp://\\1[/url]", $text);
  $text = eregi_replace("^www\\.([^ ,\r\n]*)", "[url]http://www.\\1[/url]", $text);  
  //Horizontale Linie  
  $text = str_replace("[hr]", "<hr>", $text);  
  //Textformatierungen:
  $text = preg_replace("/\[b\](.*)\[\/b\]/iUms", "<b>\\1</b>", $text);
  $text = preg_replace("/\[i\](.*)\[\/i\]/iUms", "<i>\\1</i>", $text);
  $text = preg_replace("/\[u\](.*)\[\/u\]/iUms", "<u>\\1</u>", $text);
  $text = preg_replace("/\[s\](.*)\[\/s\]/iUms", "<strike>\\1</strike>", $text);    
  //E-Mail Adresse:
  $text = preg_replace("/\[email\](.*)\[\/email\]/msiU", "<a href=\"mailto:\\1\">\\1</a>", $text);  
  //[URL]-Links:
  $text = preg_replace("/\[url\]www.(.*)\[\/url\]/iUms", "<a href=\"http://www.\\1\" target=\"_blank\">http://www.\\1</a>", $text);
  $text = preg_replace("/\[url\](.*)\[\/url\]/iUms", "<a href=\"\\1\" target=\"_blank\">\\1</a>", $text);  
  //[URL=]-Links:
  $text = preg_replace("/\[url=(.*)\](.*)\[\/url\]/iUms", "<a href=\"\\1\" target=\"_blank\">\\2</a>", $text);    
  //Bilder:
  $text = preg_replace("/\[img\](.*)\[\/img\]/iUms", "<div align=\"center\"><img src=\"\\1\" border=\"0\" alt=\"bild\"></div>", $text);  
  //Farbiger Text:
  $text = preg_replace("/\[green\](.*)\[\/green\]/iUms", "<span style=\"color:green\">\\1</span>", $text);
  $text = preg_replace("/\[red\](.*)\[\/red\]/iUms"," <span style=\"color:red\">\\1</span>", $text);
  $text = preg_replace("/\[blue\](.*)\[\/blue\]/iUms", "<span style=\"color:blue\">\\1</span>", $text);
  $text = preg_replace("/\[white\](.*)\[\/white\]/iUms", "<span style=\"color:white\">\\1</span>", $text);  
  
  return $text;
} 



/* Verarbeitet Variablen zum Schutz vor SQL-Injection-Attaken: */
function secure_sql($value){
  if (get_magic_quotes_gpc()) {
    $value = stripslashes($value);
  }
  if (!is_int($value)) {
    $value = "'" . mysql_real_escape_string($value) . "'";
  }
  
  return $value;
}



/* Formatiert Anzeigen Titel und Prefix fuer HTML Ausgabe */
function getPrefix($string){
  if(strspn("###", $string) == 3){
    $return = preg_split("/###/", $string);
    switch($return[0]){
      case "b":
        $return[0] = "[BIETE]&nbsp;";        
      break;
      
      case "s":
        $return[0] = "[SUCHE]&nbsp;";
      break;
      
      case "t";
        $return[0] = "[TAUSCHE]&nbsp;";
      break;      
    }  
  }else{
    $return[0] = "";
    $return[1] = $string;
  }
  $return = $return[0].$return[1];
  
  return $return;
}



/* Gibt Prefix Code und Anzeigen Titel getrennt zurueck */
function stripPrefix($string){
  if(strspn("###", $string) == 3)
    $return = preg_split("/###/", $string);
  else
    $return = array("n", $string);  
  return $return;
}



/* Gibt den HTML-Tag fuer das Prefix Select Feld Zurueck */
function getPrefixTag($prefix){
  switch($prefix){
    case "b":
      $prefixTag = "<select name=\"anz_prefix\" class=\"form\">\n";
      $prefixTag.= "<option value=\"b\" SELECTED>[BIETE]</option>\n";
      $prefixTag.= "<option value=\"s\">[SUCHE]</option>\n";
      $prefixTag.= "<option value=\"t\">[TAUSCHE]</option>\n";
      $prefixTag.= "<option value=\"n\">[&nbsp;]</option>\n";
      $prefixTag.= "</select>\n";
    break;
    
    case "s":
      $prefixTag = "<select name=\"anz_prefix\" class=\"form\">\n";
      $prefixTag.= "<option value=\"b\">[BIETE]</option>\n";
      $prefixTag.= "<option value=\"s\" SELECTED>[SUCHE]</option>\n";
      $prefixTag.= "<option value=\"t\">[TAUSCHE]</option>\n";
      $prefixTag.= "<option value=\"n\">[&nbsp;]</option>\n";
      $prefixTag.= "</select>\n";
    break;
    
    case "t":
      $prefixTag = "<select name=\"anz_prefix\" class=\"form\">\n";
      $prefixTag.="<option value=\"b\">[BIETE]</option>\n";
      $prefixTag.="<option value=\"s\">[SUCHE]</option>\n";
      $prefixTag.="<option value=\"t\" SELECTED>[TAUSCHE]</option>\n";
      $prefixTag.="<option value=\"n\">[&nbsp;]</option>\n";
      $prefixTag.="</select>\n";
    break;
    
    case "n":
      $prefixTag = "<select name=\"anz_prefix\" class=\"form\">\n";
      $prefixTag.= "<option value=\"b\">[BIETE]</option>\n";
      $prefixTag.= "<option value=\"s\">[SUCHE]</option>\n";
      $prefixTag.= "<option value=\"t\">[TAUSCHE]</option>\n";
      $prefixTag.= "<option value=\"n\" SELECTED>[&nbsp;]</option>\n";
      $prefixTag.= "</select>\n";
    break;
    
    default:
      $prefixTag = "<select name=\"anz_prefix\" class=\"form\">\n";
      $prefixTag.= "<option value=\"b\">[BIETE]</option>\n";
      $prefixTag.= "<option value=\"s\">[SUCHE]</option>\n";
      $prefixTag.= "<option value=\"t\">[TAUSCHE]</option>\n";
      $prefixTag.= "<option value=\"n\">[&nbsp;]</option>\n";
      $prefixTag.= "</select>\n";
    break;   
  }
  
  return $prefixTag;
}



/* Funktion zum Hochladen eines Bildes
 * Parameter:
 * $imageName: Dateiname des Bildes (aus dem Formular)
 * $newImageName: neuer Dateiname (ohne Endung)
 *
 * Rueckgabewerte:
 * $return[0] = neuer Dateiname mit Endung
 * $return[1] = evtl. Fehlermeldungen */
 
function uploadImage($imageName, $newImageName){
  global $settings, $filetypes;
  
  $filename = strtolower($_FILES[$imageName]['name']);
  $filetype = $_FILES[$imageName]['type'];
  $filesize = $_FILES[$imageName]['size'];  
  $extension = substr(strrchr($filename,"."),1);
  $thumbname = $newImageName."_pre.".$extension;
  $newImageName = $newImageName.".".$extension;  
  $return[0] = $newImageName;
  
  if($filesize > $settings['maxfilesize'])
    $return[1] = "Die Datei ist zu gro&szlig;";
  if(!in_array($filetype, $filetypes))
    $return[1] = "Dieses Dateiformat wird nicht unterst&uuml;tzt!";
  
  if(empty($return[1])){
    if(is_uploaded_file($_FILES[$imageName]['tmp_name'])){
      move_uploaded_file($_FILES[$imageName]['tmp_name'], $settings['imagefolder'].$newImageName) OR die("Fehler beim Upload der Datei!");
      chmod($settings['imagefolder'].$newImageName, 0644);
      
      $imagedata = getimagesize($settings['imagefolder'].$newImageName);
      
      switch($imagedata[2]){      
        case 1: //Es handelt sich um ein GIF-Bild        
          if($imagedata[0] > $settings['pre_width']){ // Thumbgr. ist kleiner als Quellbild -> Thumb erzeugen                    
            $x = $settings['pre_width'];
            $y = ($settings['pre_width'] / $imagedata[0]) * $imagedata[1];
            $y = round($y,0);                      
            $src = ImageCreateFromGIF($settings['imagefolder'].$newImageName);
            $dst = ImageCreateTrueColor($x, $y);                    
            ImageCopyResampled($dst,$src,0,0,0,0,$x,$y,$imagedata[0],$imagedata[1]);                
            ImageGIF($dst, $settings['imagefolder'].$thumbname);
            chmod($settings['imagefolder'].$thumbname, 0644);}              
          else{ // Thumbgr. ist groesser als Quelle -> Quelle als Thumb weiterverwenden            
            copy($settings['imagefolder'].$newImageName, $settings['imagefolder'].$thumbname);
            chmod($settings['imagefolder'].$thumbname, 0644);
          }
        break;
        
        case 2: //Es handelt sich um ein JPG-Bild        
          if($imagedata[0] > $settings['pre_width']){ // Thumbgr. ist kleiner als Quellbild -> Thumb erzeugen          
            $x = $settings['pre_width'];
            $y = ($settings['pre_width'] / $imagedata[0]) * $imagedata[1];
            $y = round($y,0);                      
            $src = ImageCreateFromJPEG($settings['imagefolder'].$newImageName);
            $dst = ImageCreateTrueColor($x, $y);                    
            ImageCopyResampled($dst,$src,0,0,0,0,$x,$y,$imagedata[0],$imagedata[1]);                
            ImageJPEG($dst, $settings['imagefolder'].$thumbname);
            chmod($settings['imagefolder'].$thumbname, 0644);}
          else{ // Thumbgr. ist groesser als Quelle -> Quelle als Thumb weiterverwenden            
            copy($settings['imagefolder'].$newfilename, $settings['imagefolder'].$thumbname);
            chmod($settings['imagefolder'].$thumbname, 0644);
          }
        break;
        
        case 3: //Es handelt sich um ein PNG-Bild        
          if($imagedata[0] > $settings['pre_width']){ // Thumbgr. ist kleiner als Quellbild -> Thumb erzeugen          
            $x = $settings['pre_width'];
            $y = ($settings['pre_width'] / $imagedata[0]) * $imagedata[1];
            $y = round($y, 0);                      
            $src = ImageCreateFromPNG($settings['imagefolder'].$newImageName);
            $dst = ImageCreateTrueColor($x,$y);                    
            ImageCopyResampled($dst,$src,0,0,0,0,$x,$y,$imagedata[0],$imagedata[1]);                
            ImagePNG($dst, $settings['imagefolder'].$thumbname);
            chmod($settings['imagefolder'].$thumbname, 0644);}
          else{ // Thumbgr. ist groesser als Quelle -> Quelle als Thumb weiterverwenden            
            copy($settings['imagefolder'].$newImageName, $settings['imagefolder'].$thumbname);
            chmod($settings['imagefolder'].$thumbname, 0644);
          }
        break;      
      }     
    }
  }
  
  return $return;
}


/* Gibt den Nickname zu einer UserID zurueck */
function getNick($id){
  global $membertable, $link;
  
  $sql = "SELECT nickname FROM ".$membertable." WHERE ID = '".$id."'";
  $res = mysql_query($sql, $link) OR die("MySQL-Fehler: ".mysql_error());
  $nick = mysql_result($res, 0, 'nickname');
  
  return stripslashes($nick);
}



/* Gibt den Userstatus als Wort zurueck */
function getStatus($stat){
  switch($stat){
    case 0: $stat = "Inaktiv"; break;
    case 1: $stat = "Aktiv"; break;
    case 2: $stat = "Gesperrt"; break;
  }
  
  return $stat;
}


/* ---- BLOWFISH FUNKTIONEN --- */

//Einen Text in Longzahlen umwandeln
//Covert a string into longinteger
function _str2long($data){
  $n = strlen($data);
  $tmp = unpack('N*', $data);
  $data_long = array();
  $j = 0;

  foreach ($tmp as $value) $data_long[$j++] = $value;
  return $data_long;
}

//Longzahlen in Text umwandeln
//Convert a longinteger into a string
function _long2str($l){

  return pack('N', $l);
}

//Key-Algorithmen
function keys($key){

  global $pbox,$sbox0,$sbox1,$sbox2,$sbox3;
  $key_md5 = md5($key);

  //Fllt den $key auf 16 Stellen auf
  //Convert the $key into a 16Byte key
  $key = _str2long(substr(str_pad($key, 16, $key_md5),0,16));


  # XOR Pbox1 with the first 32 bits of the key, XOR P2 with the second 32-bits of the key,
  for($i=0;$i<count($pbox);$i++)
     {
     $pbox[$i] ^= $key[$i%4];
     }

  $v[0] = 0x00000000;
  $v[1] = 0x00000000;

  //P-Box durch verschlsselte Nullbit Blcke ersetzen. In der nchsten Runde das Resultat erneut verschlsseln
  //Encrypt Nullbit Blocks and replace the Pbox with the Chiffre. Next round, encrypt the result
  for($i=0;$i<count($pbox);$i+=2)
      {
      $v = block_encrypt(array($v[0],$v[1]));
      $pbox[$i] = $v[0];
      $pbox[$i+1] = $v[1];
      }

  //S-Box [0 bis 3] durch verschlsselte Blcke ersetzen
  //Replace S-Box [0 to 3] entries with encrypted blocks
  for($i=0;$i<count($sbox0);$i+=2)
      {
      $v = block_encrypt(array($v[0],$v[1]));
      $sbox0[$i] = $v[0];
      $sbox0[$i+1] = $v[1];
      }

  //S-Box1
  for($i=0;$i<count($sbox1);$i+=2)
      {
      $v = block_encrypt(array($v[0],$v[1]));
      $sbox1[$i] = $v[0];
      $sbox1[$i+1] = $v[1];
      }

  //S-Box2
  for($i=0;$i<count($sbox2);$i+=2)
      {
      $v = block_encrypt(array($v[0],$v[1]));
      $sbox2[$i] = $v[0];
      $sbox2[$i+1] = $v[1];
      }

  //S-Box3
  for($i=0;$i<count($sbox3);$i+=2)
      {
      $v = block_encrypt(array($v[0],$v[1]));
      $sbox3[$i] = $v[0];
      $sbox3[$i+1] = $v[1];
      }

  return $key;
}

//Verschlsselung ($text = text/string)
//Encrytion
function blowfish_crypt($text){
  $n = strlen($text);
  if($n%8 != 0) $lng = ($n+(8-($n%8)));
  else $lng = 0;

  $text = str_pad($text, $lng, ' ');
  $text = _str2long($text);

  //Initialization vector: IV
  if(CBC == 1)
     {
     $cipher[0][0] = time();
     $cipher[0][1] = (double)microtime()*1000000;
     }

  $a = 1;
  for($i = 0; $i<count($text); $i+=2)
      {
      if(CBC == 1)
         {
         //$text mit letztem Geheimtext XOR Verknpfen
         //$text is XORed with the previous ciphertext
         $text[$i] ^= $cipher[$a-1][0];
         $text[$i+1] ^= $cipher[$a-1][1];
         }

      $cipher[] = block_encrypt(array($text[$i],$text[$i+1]));
      $a++;
      }

  $output = "";
  for($i = 0; $i<count($cipher); $i++)
     {
     $output .= _long2str($cipher[$i][0]);
     $output .= _long2str($cipher[$i][1]);
     }

  return base64_encode($output);
}

//Entschlsseln
//Decryption
function blowfish_decrypt($text){
  $plain = array();
  $cipher = _str2long(base64_decode($text));

  if(CBC == 1) $i = 2; //Message start at second block
  else $i = 0; //Message start at first block

  for($i; $i<count($cipher); $i+=2)
     {
     $return = block_decrypt(array($cipher[$i],$cipher[$i+1]));

     if(CBC == 1)
        {
        //Xor Verknpfung von $return und Geheimtext aus von den letzten beiden Blcken
        //XORed $return with the previous ciphertext
        $plain[] = array($return[0]^$cipher[$i-2],$return[1]^$cipher[$i-1]);
        }
     else          //EBC Mode
        {
        $plain[] = $return;
        }
     }

  for($i = 0; $i<count($plain); $i++)
     {
     $output .= _long2str($plain[$i][0]);
     $output .= _long2str($plain[$i][1]);
     }
  return $output;
}

function block_encrypt($text){
  global $pbox;
  $vl = $text[0];
  $vr = $text[1];

  for($i=0;$i<16;$i++)
    {
    $vl ^= $pbox[$i];
    $vr ^= sbox_round($vl);

    $v_tmp = $vl;
    $vl = $vr;
    $vr = $v_tmp;
    }

  $v_tmp = $vl;
  $vl = $vr;
  $vr = $v_tmp;

  $vr ^= $pbox[16];
  $vl ^= $pbox[17];


  return array($vl,$vr);
}

function block_decrypt($text){
  global $pbox;

  $vl = $text[0];
  $vr = $text[1];

  for($i=17;$i>1;$i--)
    {
    $vl ^= $pbox[$i];
    $vr ^= sbox_round($vl);

    $v_tmp = $vl;
    $vl = $vr;
    $vr = $v_tmp;
    }

  $v_tmp = $vl;
  $vl = $vr;
  $vr = $v_tmp;

  $vr ^= $pbox[1];
  $vl ^= $pbox[0];

  return array($vl,$vr);
}

function sbox_round($integer){
  global $sbox0,$sbox1,$sbox2,$sbox3;

  //$integer in vier 8 Bit Blcke unterteilen
  //Split $integer into four 8 Bit blocks
  $b0 = $integer<<24 & 0xFF;
  $b1 = $integer<<16 & 0xFF;
  $b2 = $integer<<8 & 0xFF;
  $b3 = $integer & 0xFF;
  

  $return = ($sbox0[$b0] + $sbox1[$b1] % pow(2,32)) ;
  $return = ($return ^ $sbox2[$b2]) + $sbox3[$b3] % pow(2,32);

  return $return;
}
/* --- ENDE BLOWFISH FUNKTIONEN --- */
?>